<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'user';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);
$smarty->assign('submenu', 'book_item');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 实例化
include_once (ROOT_PATH . 'include/book.class.php');
$dou_book = new Book();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/book/', null, 'jpg,gif,png', '2048'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 预约套餐列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['book_class']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['book_class_add'],
            'href' => 'book_class.php?rec=add' 
    ));
    
    // 赋值给模板
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    
    $smarty->display('book_class.htm');
} 

/**
 * +----------------------------------------------------------
 *  预约套餐添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['book_class_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['book_class'],
            'href' => 'book_class.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    
    $smarty->display('book_class.htm');
} 

elseif ($rec == 'insert') {
    // 判断是否为空
    $wrong = $check->fn_empty('book_class', 'class_name');
 
    // 显示错误提示
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $dou->dou_msg($wrong[$key]);;
        }
    }
    
    // 文件上传盒子
    $auto_id = $dou->auto_id('book_class');
    $icon = $file->box('book_class', $auto_id, 'icon', 'main', 'class_' . $auto_id);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('book_class') . " (class_id, unique_id, class_name, icon, parent_id, sort)" . " VALUES (NULL, '$_POST[unique_id]', '$_POST[class_name]', '$icon', '$_POST[parent_id]', '$_POST[sort]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['book_class_add'] . ': ' . $_POST['class_name']);
    $dou->dou_msg($_LANG['book_class_add'] . $_LANG['success'], 'book_class.php');
} 

/**
 * +----------------------------------------------------------
 *  预约套餐编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['book_class_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['book_class'],
            'href' => 'book_class.php' 
    ));
    
    // 验证并获取合法的ID
    $class_id = $check->is_number($_REQUEST['class_id']) ? $_REQUEST['class_id'] : '';
    
    $class = $dou->get_row('book_class', '*', "class_id = '$class_id'");
    
    // 格式化数据
    $class['icon'] = $dou->dou_file($class['icon']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('class', $class);
    $smarty->assign('class_list', $dou_book->get_class_nolevel('0', '0', $class_id));
    
    $smarty->display('book_class.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $class_id = $check->is_number($_POST['class_id']) ? $_POST['class_id'] : '';
    
    // 判断是否为空
    $wrong = $check->fn_empty('book_class', 'class_name');
 
    // 显示错误提示
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $dou->dou_msg($wrong[$key]);;
        }
    }
    
    // 文件上传盒子
    $icon = $file->box('book_class', $class_id, 'icon', 'main', 'class_' . $class_id);
    $icon = $icon ? ", icon = '" . $icon . "'" : '';
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('book_class') . " SET unique_id = '$_POST[unique_id]', class_name = '$_POST[class_name]'" . $icon . ", parent_id = '$_POST[parent_id]', sort = '$_POST[sort]' WHERE class_id = '$class_id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['book_class_edit'] . ': ' . $_POST['class_name']);
    $dou->dou_msg($_LANG['book_class_edit'] . $_LANG['success'], 'book_class.php');
}

/**
 * +----------------------------------------------------------
 * 预约套餐删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的user_id
    $class_id = $check->is_number($_REQUEST['class_id']) ? $_REQUEST['class_id'] : $dou->dou_msg($_LANG['illegal'], 'book_class.php');
    $class_name = $dou->get_one("SELECT class_name FROM " . $dou->table('book_class') . " WHERE class_id = '$class_id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['book_class_del'] . ': ' . $class_name);
        $dou->delete('book_class', "class_id = $class_id", 'book_class.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $class_name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'book_class.php', '', '30', "book_class.php?rec=del&class_id=$class_id");
    }
}

?>