<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'book';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);
$smarty->assign('submenu', 'book_item');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 实例化
include_once (ROOT_PATH . 'include/book.class.php');
$dou_book = new Book();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/book/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 项目列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['book_item']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['book_item_add'],
            'href' => 'book_item.php?rec=add' 
    ));
    
    // 获取参数
    $class_id = $check->is_number($_REQUEST['class_id']) ? $_REQUEST['class_id'] : '';
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    if ($class_id)
        $where = ' WHERE class_id IN (' . $class_id . $dou->dou_child_id('book_class', $class_id) . ')';
    if ($keyword) {
        $where = $where . " AND name LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
 
    // 排序
    $sort = $_OPEN['sort'] ? "sort ASC, " : '';
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('book_item') . $where . " ORDER BY " . $sort . "id DESC";
 
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'book_item.php' . ($class_id ? '?class_id=' . $class_id : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $item_list[] = array (
                "id" => $row['id'],
                "class_id" => $row['class_id'],
                "class_name" => $dou->get_value('book_class', 'class_name', "class_id = '$row[class_id]'"),
                "name" => $row['name'],
                "tag" => $row['tag'],
                "day_number" => $row['day_number'],
                "image" => $dou->dou_file($row['image']),
                "sort" => $row['sort'],
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
 
    // 赋值给模板
    $smarty->assign('class_id', $class_id);
    $smarty->assign('keyword', $keyword);
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    $smarty->assign('item_list', $item_list);
    
    $smarty->display('book_item.htm');
} 

/**
 * +----------------------------------------------------------
 * 项目添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['book_item_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['book_item'],
            'href' => 'book_item.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    $smarty->assign('item_id', $dou->auto_id('book_item'));
    $smarty->assign('btn_lang', $dou->btn_lang('article', '', 'name, tag, brief, content'));
    
    $smarty->display('book_item.htm');
} 

elseif ($rec == 'insert') {
    // 验证标题
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['book_item_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('book_item', $dou->auto_id('book_item'), 'image', 'main');
    
    // 数据格式化
    $add_time = time();
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('book_item') . " (id, class_id, name, tag, day_number, monday, tuesday, wednesday, thursday, friday, saturday, sunday, image, brief, content, sort, add_time)" . " VALUES (NULL, '$_POST[class_id]', '$_POST[name]', '$_POST[tag]', '$_POST[day_number]', '$_POST[monday]', '$_POST[tuesday]', '$_POST[wednesday]', '$_POST[thursday]', '$_POST[friday]', '$_POST[saturday]', '$_POST[sunday]', '$image', '$_POST[brief]', '$_POST[content]', '$_POST[sort]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['book_item_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['book_item_add'] . $_LANG['success'], 'book_item.php');
} 

/**
 * +----------------------------------------------------------
 * 项目编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['book_item_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['book_item'],
            'href' => 'book_item.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $item = $dou->get_row('book_item', '*', "id = '$id'");
    
    // 格式化数据
    $item['image'] = $dou->dou_file($item['image']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    $smarty->assign('item_id', $id);
    $smarty->assign('item_content', $item['content']);
    $smarty->assign('item', $item);
    $smarty->assign('btn_lang', $dou->btn_lang('item', $id, 'name, tag, brief, content'));
    
    $smarty->display('book_item.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证标题
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['book_item_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('book_item', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('book_item') . " SET class_id = '$_POST[class_id]', name = '$_POST[name]', tag = '$_POST[tag]', day_number = '$_POST[day_number]', monday = '$_POST[monday]', tuesday = '$_POST[tuesday]', wednesday = '$_POST[wednesday]', thursday = '$_POST[thursday]', friday = '$_POST[friday]', saturday = '$_POST[saturday]', sunday = '$_POST[sunday]'" . $image . ", brief = '$_POST[brief]', content = '$_POST[content]', sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['book_item_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['book_item_edit'] . $_LANG['success'], 'book_item.php');
}

/**
 * +----------------------------------------------------------
 * 项目删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'book_item.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('book_item') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('book_item') . " WHERE id = '$id'");
        $dou->del_file($image);
         
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('book_item', $id);
        
        $dou->create_admin_log($_LANG['book_item_del'] . ': ' . $name);
        $dou->delete('book_item', "id = '$id'", 'book_item.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'book_item.php', '', '30', "book_item.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量项目删除
            $dou->del_all('book_item', $_POST['checkbox'], 'id', 'image');
        } elseif ($_POST['action'] == 'category_move') {
            // 批量移动分类
            $dou->category_move('book_item', $_POST['checkbox'], $_POST['new_class_id']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['book_item_select_empty']);
    }
}

?>