<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'list|class|detail|time|date|contact|booking|user|work|consume';
$subbox = array(
        "module" => 'book',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'book';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// 实例化
include_once (ROOT_PATH . 'include/book.class.php');
$dou_book = new Book();

// 工作端实例化
if ($_OPEN['work']) {
    include_once (ROOT_PATH . 'include/work.class.php');
    $dou_work = new Work();
}

// 操作项的初始化
if ($check->is_class($_REQUEST['class'])) {
    $class = $_REQUEST['class'];
    $rec = 'list';
} else {
    $rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : ($dou->row_exist('book_class') ? 'class' : 'list');
}

// 需要登录且没有登录的情况
if (!is_array($_GLOBAL_USER)) {
    $dou->dou_header($_URL['login']);
} else {
    $user_id = $_GLOBAL_USER['user_id'];
}

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'book', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 预约列表
 * +----------------------------------------------------------
 */
if ($rec == 'list') {
    if ($class) {
        $class_info = $dou->get_row('book_class', '*', "unique_id = '$class'");
     
        if (!$class_info) {
            $dou->dou_msg('page_wrong', HOME_URL);
        } elseif ($class) {
            $where = ' WHERE class_id IN (' . $class_info['class_id'] . $dou_book->child_id($class_info['class_id']) . ')';
        }
    }

    $sql = "SELECT * FROM " . $dou->table('book_item') . $where . " ORDER BY sort ASC, id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, ($_DISPLAY['book'] ? $_DISPLAY['book'] : 30), $page, $dou->rewrite_url('book', 'class', $class));

    /* 获取文章列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $item_list[] = array (
                "id" => $row['id'],
                "class_name" => $dou->get_value('book_class', 'class_name', "class_id = '$row[class_id]'"),
                "name" => $row['name'],
                "tag" => $row['tag'],
                "brief" => $row['brief'],
                "image" => $dou->dou_file($row['image']),
                "url" => $dou->rewrite_url('book', $row['id'])
        );
    }

    // 赋值给模板-meta和title信息
    $smarty->assign('page_title', $dou->page_title('book'));
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('book'));
    $smarty->assign('ur_here', $dou->ur_here('book'));
    $smarty->assign('head', $_LANG['book']);
    $smarty->assign('item_list', $item_list);
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    
    $smarty->display('book.dwt');
}

/**
 * +----------------------------------------------------------
 * 分类页
 * +----------------------------------------------------------
 */
elseif ($rec == 'class') {
    // 赋值给模板-meta和title信息
    $smarty->assign('page_title', $dou->page_title('book_class'));
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('book'));
    $smarty->assign('ur_here', $dou->ur_here('book'));
    $smarty->assign('head', $_LANG['book_class']);
    $smarty->assign('class_list', $dou_book->get_class_nolevel());
    
    $smarty->display('book.dwt');
}

/**
 * +----------------------------------------------------------
 * 简介
 * +----------------------------------------------------------
 */
elseif ($rec == 'detail') {
    // 获取ID
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    
    /* 获取详细信息 */
    $book = $dou->get_row('book_item', '*', "id = '$id'");
    if (!$book) $dou->dou_msg('page_wrong', HOME_URL);
    
    // 格式化数据
    $book['image'] = $dou->dou_file($item['image']);

    // 多语言
    $book = $dou->lang_box($book, 'book_item', 'name, brief, content');
 
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('book', '', $book['name']));
    $smarty->assign('ur_here', $dou->ur_here('book', '', $book['name']));
    $smarty->assign('head', $book['name']);
    $smarty->assign('book', $book);

    $smarty->display('book.dwt');
}

/**
 * +----------------------------------------------------------
 * 日期列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'date') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $current_date = $check->is_date($_REQUEST['current_date']) ? trim($_REQUEST['current_date']) : '';
    
    $date_list = $dou_book->get_date_list($id, $current_date);
    
    $data['date_list'] = $date_list;
    $data['date'] = $date_list[0]['date'];

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 时间列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'time') {
    // 获取ID
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $current_time = $check->is_time($_REQUEST['current_time']) ? trim($_REQUEST['current_time']) : '';
    
    // 日期
    $date = $check->is_date($_REQUEST['date']) ? trim($_REQUEST['date']) : '';
    
    $data['date'] = $date;
    $data['time_list'] = $dou_book->get_time_list($id, $date, $current_time);

    echo json_encode($data);
}

/**
 * +----------------------------------------------------------
 * 预约人选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'contact') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $date = $check->is_date($_REQUEST['date']) ? trim($_REQUEST['date']) : '';
    $time = $check->is_time($_REQUEST['time']) ? trim($_REQUEST['time']) : '';
 
    // 验证是否选择和选择的时间是否正确
    if (!$date || !$time) {
        $wrong['time'] = $_LANG['book_time_empty'];
    } elseif ($dou_book->booked($id, $date, $time) || !$dou_book->time_with($id, $date, $time)) {
        $wrong['time'] = $_LANG['book_time_wrong'];
    }
 
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['consultation']);
    }
    
    // 格式化
    $item = $dou->get_row('book_item', '*', "id = '$id'");
    $item['class_name'] = $dou->get_value('book_class', 'class_name', "class_id = '$item[class_id]'");
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('book', 'book_item'));
    $smarty->assign('ur_here', $dou->ur_here('book', 'book_item'));
    $smarty->assign('head', $_LANG['book_class']);
    $smarty->assign('item', $item);
    $smarty->assign('date', $date);
    $smarty->assign('time', $time);
    $smarty->assign('time_format', $date . ' ' . $time);

    $smarty->display('book.dwt');
}

/**
 * +----------------------------------------------------------
 * 预约提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'booking') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $contact_id = $check->is_number($_REQUEST['contact_id']) ? trim($_REQUEST['contact_id']) : '';
    $date = $check->is_date($_REQUEST['date']) ? trim($_REQUEST['date']) : '';
    $time = $check->is_time($_REQUEST['time']) ? trim($_REQUEST['time']) : '';
 
    // 转为时间戳
    $timestamp = $dou_book->timestamp($date, $time);
    
    // 验证是否选择和选择的时间是否正确
    if (!$date || !$time) {
        $wrong['time'] = $_LANG['book_time_empty'];
    } elseif ($dou_book->booked($id, $date, $time) || !$dou_book->time_with($id, $date, $time)) {
        $wrong['time'] = $_LANG['book_time_wrong'];
    }
 
    // 验证是否超过预约次数
    if (!$dou_book->check_number($id, $contact_id))
        $wrong['contact_id'] = $_LANG['book_number_out'];
 
    // 判断联系人
    if (!$contact_id || !$dou->value_exist('user_contact', 'id', $contact_id, "user_id = '$user_id'"))
        $wrong['contact_id'] = $_LANG['book_contact_wrong'];
    
    // 格式化
    $item = $dou->get_row('book_item', '*', "id = '$id'");
    $contact = $dou->get_row('user_contact', '*', "id = '$contact_id'");
    
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['consultation']);
    }
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    $ip = $dou->get_ip();
    $add_time = time();
    $book_sn = $dou_book->create_book_sn();
    
    $sql = "INSERT INTO " . $dou->table('book') . " (id, book_sn, user_id, class_id, item_id, contact_id, name, telphone, card, date, time, timestamp, ip, add_time)" . " VALUES (NULL, '$book_sn', '$user_id', '$item[class_id]', '$item[id]', '$contact_id', '$contact[name]', '$contact[telphone]', '$contact[card]', '$date', '$time', '$timestamp', '$ip', '$add_time')";
    $dou->query($sql);
    
    $dou->dou_msg($_LANG['book_success'], $_URL['sub']['user']);
}

/**
 * +----------------------------------------------------------
 * 会员中心
 * +----------------------------------------------------------
 */
elseif ($rec == 'user') {
    // 超时取消预约
    $dou_book->auto_update_status("user_id = '$user_id'");
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('book') . " WHERE user_id = '$user_id' ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $_URL['sub']['user']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $book_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "item_name" => $dou->get_value('book_item', 'name', "id = '$row[item_id]'"),
                "name" => $row['name'],
                "telphone" => $row['telphone'],
                "card" => $row['card'],
                "time" => $row['date'] . ' ' . $row['time'],
                "status" => $dou->data_lang_format('book_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }

    // 赋值给模板
    $smarty->assign('page_title', $dou->page_title('user', 'book_user'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'book_user'));
    $smarty->assign('head', $_LANG['book_user']);
    $smarty->assign('book_list', $book_list);
    $smarty->assign('link_user_center', $dou_user->link_user_center($_CUR));

    $smarty->display('book_user.dwt');
}

/**
 * +----------------------------------------------------------
 * 工作端
 * +----------------------------------------------------------
 */
elseif ($rec == 'work') {
    // 权限验证
    if (!$dou_work->check_permission($_CUR))
        $dou->dou_msg($_LANG['work_no_permission'], $_URL['work']);

    // 超时取消预约
    $dou_book->auto_update_status();
 
    // 初始化
    $page_url = $_URL['sub']['work'];
 
    // 用户名
    $info = preg_match("/^[0-9\x{4e00}-\x{9fa5}]+$/u", $_REQUEST['info']) ? $_REQUEST['info'] : '';
    if ($info) {
        $and = " AND (name = '$info' OR telphone LIKE '%$info%')";
        $page_url = $page_url . "&info=$info";
    }
    
    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $and = $and . " AND time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $and = $and . " AND time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $page_url = $dou->param($page_url);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('book') . " WHERE status = 0" . $and . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $book_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "item_name" => $dou->get_value('book_item', 'name', "id = '$row[item_id]'"),
                "name" => $row['name'],
                "telphone" => $row['telphone'],
                "card" => $row['card'],
                "time" => $row['date'] . ' ' . $row['time'],
                "status" => $dou->data_lang_format('book_status_', $row['status']),
                "url_action" => $dou->param($_URL['sub']['consume'] . '&id=' . $row['id']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板 
    $smarty->assign('page_title', $dou->page_title('user', 'book_work'));
    $smarty->assign('ur_here', $dou->ur_here('user', 'book_work'));
    $smarty->assign('head', $_LANG['book_work']);
    $smarty->assign('book_list', $book_list);
    $smarty->assign('link_work_center', $dou_work->link_work_center($_CUR));
    $smarty->assign('req', $_REQUEST);

    $smarty->display('book_work.dwt');
}

/**
 * +----------------------------------------------------------
 * 工作端 核销
 * +----------------------------------------------------------
 */
elseif ($rec == 'consume') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 权限验证
    if (!$dou_work->check_permission($_CUR))
        $dou->dou_msg($_LANG['work_no_permission'], $_URL['work']);
    
    $dou->query("UPDATE " . $dou->table('book') . " SET status = '1' WHERE id = '$id'");
    
    $dou->dou_header($dou->rewrite_url('book', 'work', '', $_SESSION[DOU_ID]['page']));
}

?>