<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Book {
    /**
     * +----------------------------------------------------------
     * 获取无层次商品分类，将所有分类存至同一级数组，用$mark作为标记区分
     * +----------------------------------------------------------
     * $parent_id 默认获取一级导航
     * $level 无限极分类层次
     * $current_id 当前页面栏目ID
     * $class_nolevel 储存分类信息的数组
     * $mark 无限极分类标记
     * +----------------------------------------------------------
     */
    function get_class_nolevel($parent_id = 0, $level = 0, $current_id = '', &$class_nolevel = array(), $mark = '-') {
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('book_class') . " ORDER BY sort ASC, class_id ASC");
        foreach ((array) $data as $value) {
            $url = defined('IS_MINIPROGRAM') ? $GLOBALS['dou']->rewrite_url_miniprogram('book', 'list') . '?class_id=' . $value['class_id'] : $GLOBALS['dou']->rewrite_url('book', 'class', $value['unique_id']);
            
            if ($value['parent_id'] == $parent_id && $value['class_id'] != $current_id) {
                $value['url'] = $url;
                $value['icon'] = $value['icon'] ? $GLOBALS['dou']->dou_file($value['icon']) : $GLOBALS['_THEME_PATH'] . '/images/icon_book_class.png';
                $value['mark'] = str_repeat($mark, $level);
                
                $class_nolevel[] = $value;
                $this->get_class_nolevel($value['class_id'], $level + 1, $current_id, $class_nolevel);
            }
        }
        
        return $class_nolevel;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取当前分类下所有子分类
     * +----------------------------------------------------------
     * $parent_id 父类ID
     * $child_id_list 子类ID零时存储器
     * +----------------------------------------------------------
     */
    function child_id($parent_id = '0', &$child_id_list = '') {
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('book_class') . " ORDER BY sort ASC, class_id ASC");
        foreach ((array) $data as $value) {
            if ($value['parent_id'] == $parent_id) {
                $child_id_list .= ',' . $value['class_id'];
                $this->child_id($value['class_id'], $child_id_list);
            }
        }

        return $child_id_list;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取日期列表
     * +----------------------------------------------------------
     */
    function get_date_list($item_id, $current_date = '') {
        // 可预约时间范围（天）
        $day_number = $GLOBALS['_PARAM']['book_day_number'] ? $GLOBALS['_PARAM']['book_day_number'] : 7;
        
        $item = $GLOBALS['dou']->get_row('book_item', '*', "id = '$item_id'");
        
        $n = 1; // 有效循环次数
        for ($i = 0; $i < $day_number; $i++) {
            $time = strtotime("+$i days");
            $date = date('Y-m-d', $time);
            $week = strtolower(date('l', $time));
         
            if ($item[$week]) {
                $date_list[] = array (
                        "date" => $date,
                        "date_short" => date('m-d', $time),
                        "week" => $week,
                        "week_name" => $GLOBALS['_LANG']['book_item_' . $week],
                        "cur" => ($date == $current_date || (!$current_date && $n == 1)) ? true : false
                );
             
                $n++;
            }
        }
        
        return $date_list;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取日期列表
     * +----------------------------------------------------------
     */
    function date_format($time) {
        $date_now = date('Y-m-d', $time);
        $week = strtolower(date('l', $time));
        $date = array (
                "date" => $date_now,
                "week" => $week,
                "week_name" => $GLOBALS['_LANG']['book_item_' . $week]
        );
        
        return $date;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取时间列表
     * +----------------------------------------------------------
     */
    function get_time_list($item_id, $date, $current_time = '', $user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
        
        $time_list = array();
        $week = strtolower(date('l', strtotime($date)));
        $item = $GLOBALS['dou']->get_row('book_item', '*', "id = '$item_id'");
        $time_array = explode(' ', $item[$week]);
        
        foreach ((array)$time_array as $time) {
            $timestamp = $this->timestamp($date, $time);
            $book_number_limit = $this->book_number_limit($item_id, $date, $time);
            if ($GLOBALS['_PARAM']['book_number_limit'] > 1) {
                $book_number_limit_text = $book_number_limit > 0 ? $GLOBALS['_LANG']['book_number_limit_yes'] : $GLOBALS['_LANG']['book_number_limit_no'];
            } else {
                $book_number_limit_text = '';
            }
         
            if ($timestamp > time()) {
                $time_list[] = array (
                        "value" => $time,
                        "time" => $time,
                        "book_number_limit" => $book_number_limit,
                        "book_number_limit_text" => $book_number_limit_text,
                        "booked" => $this->booked($item_id, $date, $time, $user_id),
                        "cur" => $time == $current_time ? true : false
                );
            }
        }

        return $time_list;
    }
    
    /**
     * +----------------------------------------------------------
     * 获取时间戳
     * +----------------------------------------------------------
     */
    function timestamp($date, $time) {
        // 去除首尾空格
        $time = trim($time);
        // 使用正则分割所有可能的分隔符（包括~和-）
        $parts = preg_split('/[~-]/', $time);
        // 返回分割后的最后一个元素，如果还获取第一个元素，则忽略上面代码，直接使用strtok($time, "~-")
        $time_format = end($parts);
       
        $timestamp = strtotime($date . ' ' . $time_format);
        
        return $timestamp;
    }
    
    /**
     * +----------------------------------------------------------
     * 预约数量剩余
     * +----------------------------------------------------------
     */
    function book_number_limit($item_id, $date, $time) {
        $record_count = $GLOBALS['dou']->zero($GLOBALS['dou']->num_rows($GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('book') . " WHERE date = '$date' AND time = '$time' AND item_id = '$item_id'")));
     
        $book_number_limit = $GLOBALS['_PARAM']['book_number_limit'] - $record_count;
        
        return $book_number_limit < 0 ? 0 : $book_number_limit;
    }
    
    /**
     * +----------------------------------------------------------
     * 判断是否已经被预约
     * +----------------------------------------------------------
     */
    function booked($item_id, $date, $time, $user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
        $book_number_limit = $this->book_number_limit($item_id, $date, $time);
        
        return $book_number_limit == 0 || $GLOBALS['dou']->value_exist('book', 'time', $time, "item_id = '$item_id' AND user_id = '$user_id' AND date = '$date'") ? true : false;
    }
 
    /**
     * +----------------------------------------------------------
     * 判断是否在可预约时间
     * +----------------------------------------------------------
     */
    function time_with($item_id, $date, $time) {
        $day_number = $GLOBALS['_PARAM']['book_day_number'] ? $GLOBALS['_PARAM']['book_day_number'] : 7; // 可预约时间范围（天）
        $timestamp = $this->timestamp($date, $time);
        $time_now = time();
        $time_end = strtotime(date("Y-m-d", $time_now)) + ($day_number * 86400); // 1天等于86400秒
        
        // 判断在允许预约时间范围
        if ($time_now < $timestamp && $timestamp < $time_end) {
            // 判断预约时间是否在可选列表
            $week = strtolower(date('l', $timestamp));
            $item = $GLOBALS['dou']->get_row('book_item', '*', "id = '$item_id'");

            if ($item[$week]) {
                $time_array = explode(' ', $item[$week]);
                if (is_array($time_array)) {
                    if (in_array($time, $time_array)) {
                        return true;
                    }
                }
            }
        }
     
        return false;
    }
    
    /**
     * +----------------------------------------------------------
     * 验证是否超过预约次数
     * +----------------------------------------------------------
     */
    function check_number($item_id, $contact_id, $user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
        
        $book_number = $GLOBALS['dou']->row_number('book', "item_id = '$item_id' AND user_id = '$user_id' AND contact_id = '$contact_id' AND status = '0'");
     
        if ($book_number < $GLOBALS['_PARAM']['book_number'])
            return true;
    }
    
    /**
     * +----------------------------------------------------------
     * 生成唯一的预约编号
     * +----------------------------------------------------------
     */
    function create_book_sn() {
        $user_sn = $GLOBALS['_GLOBAL_USER']['user_sn'];
        
        // 随机生成订单号
        $book_sn = date('ymdHis') . str_pad(mt_rand(1, 99), 2, '0', STR_PAD_LEFT) . $user_sn;
     
        return $book_sn;
    }
 
    /**
     * +----------------------------------------------------------
     * 超时取消预约
     * +----------------------------------------------------------
     */
    function auto_update_status($and = '') {
        $and = $and ? " AND $and" : '';
        $timeout = ($GLOBALS['_PARAM']['book_timeout'] ? $GLOBALS['_PARAM']['book_timeout'] : 30) * 60; // 60秒等于1分钟，默认为30分钟
        $time_limit = time() - $timeout;

        // 超过期限将售后状态标记为不可申请售后
        $sql = "UPDATE " . $GLOBALS['dou']->table('book') . " SET status = '-1' WHERE status = '0' AND timestamp < '$time_limit'" . $and;
        $GLOBALS['dou']->query($sql);
    }
    
}
?>