<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'list|detail|contact|user|work';
$subbox = array(
        "module" => 'book',
        "sub" => $sub
);

$_CUR = 'book';
require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/book.class.php');
$dou_book = new Book();

// 实例化
if ($_OPEN['work']) {
    include_once (ROOT_PATH . 'include/work.class.php');
    $dou_work = new Work();
}

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    $data['wrong'] = $_LANG['login_timeout'];
    die(json_encode($data));
}

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 引导页
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $data['class_exist'] = $dou->row_exist('book_class');
}

/**
 * +----------------------------------------------------------
 * 预约列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'list') {
    if ($class) {
        $class_info = $dou->get_row('book_class', '*', "unique_id = '$class'");
     
        if (!$class_info) {
            $dou->dou_msg('page_wrong', HOME_URL);
        } elseif ($class) {
            $where = ' WHERE class_id IN (' . $class_info['class_id'] . $dou_book->child_id($class_info['class_id']) . ')';
        }
    }

    $sql = "SELECT * FROM " . $dou->table('book_item') . $where . " ORDER BY sort ASC, id DESC";

    // 获取分页信息
    $page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
    $limit = $dou->pager($sql, ($_DISPLAY['book'] ? $_DISPLAY['book'] : 30), $page, $dou->rewrite_url('book', 'class', $class));

    /* 获取文章列表 */
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $item_list[] = array (
                "id" => $row['id'],
                "class_name" => $dou->get_value('book_class', 'class_name', "class_id = '$row[class_id]'"),
                "name" => $row['name'],
                "tag" => $row['tag'],
                "brief" => $row['brief'],
                "image" => $dou->dou_file($row['image']),
                "url" => $dou->rewrite_url_miniprogram('book', $row['id'])
        );
    }

    // 数据封装
    $data['title'] = $_LANG['book'];
    $data['item_list'] = $item_list;
}

/**
 * +----------------------------------------------------------
 * 分类页
 * +----------------------------------------------------------
 */
elseif ($rec == 'class') {
    // 数据封装
    $data['title'] = $_LANG['book'];
    $data['class_list'] = $dou_book->get_class_nolevel();
}

/**
 * +----------------------------------------------------------
 * 简介
 * +----------------------------------------------------------
 */
elseif ($rec == 'detail') {
    // 获取ID
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    
    /* 获取详细信息 */
    $book = $dou->get_row('book_item', '*', "id = '$id'");
    
    // 格式化数据
    $book['image'] = $dou->dou_file($item['image']);

    // 多语言
    $book = $dou->lang_box($book, 'book_item', 'name, brief, content');
 
    // 数据封装
    $data['title'] = $book['name'];
    $data['book'] = $book;
}

/**
 * +----------------------------------------------------------
 * 日期列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'date') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $current_date = $check->is_date($_REQUEST['current_date']) ? trim($_REQUEST['current_date']) : '';
    
    $date_list = $dou_book->get_date_list($id, $current_date);
    
    // 数据封装
    $data['date_list'] = $date_list;
    $data['date'] = $date_list[0]['date'];
}

/**
 * +----------------------------------------------------------
 * 时间列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'time') {
    // 获取ID
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $current_time = $check->is_time($_REQUEST['current_time']) ? trim($_REQUEST['current_time']) : '';
    
    // 日期
    $date = $check->is_date($_REQUEST['date']) ? trim($_REQUEST['date']) : '';
    
    // 数据封装
    $data['date'] = $date;
    $data['time_list'] = $dou_book->get_time_list($id, $date, $current_time, $user_id);
}

/**
 * +----------------------------------------------------------
 * 预约人选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'contact') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $date = $check->is_date($_REQUEST['date']) ? trim($_REQUEST['date']) : '';
    $time = $check->is_time($_REQUEST['time']) ? trim($_REQUEST['time']) : '';
    
    // 验证是否选择和选择的时间是否正确
    if (!$date || !$time) {
        $data['wrong'] = $_LANG['book_time_empty'];
        die(json_encode($data));
    } elseif ($dou_book->booked($id, $date, $time, $user_id) || !$dou_book->time_with($id, $date, $time)) {
        $data['wrong'] = $_LANG['book_time_wrong'];
        die(json_encode($data));
    }
    
    // 格式化
    $item = $dou->get_row('book_item', '*', "id = '$id'");
    $item['class_name'] = $dou->get_value('book_class', 'class_name', "class_id = '$item[class_id]'");
    
    // 数据封装
    $data['item'] = $item;
    $data['date'] = $date;
    $data['time'] = $time;
    $data['time_format'] = $date . ' ' . $time;
}

/**
 * +----------------------------------------------------------
 * 预约人选定
 * +----------------------------------------------------------
 */
elseif ($rec == 'contact_list') {
    // 获取请求
    $contact_id = $check->is_number($_REQUEST['contact_id']) ? trim($_REQUEST['contact_id']) : $dou->get_value('user_contact', 'id', "user_id = '$user_id' ORDER BY `default` DESC, id DESC");
    
    // 数据封装
    $data['contact_list'] = $dou_user->contact_list($user_id, $contact_id);
}

/**
 * +----------------------------------------------------------
 * 预约人选定
 * +----------------------------------------------------------
 */
elseif ($rec == 'contact_select') {
    // 获取请求
    $contact_id = $check->is_number($_REQUEST['contact_id']) ? trim($_REQUEST['contact_id']) : $dou->get_value('user_contact', 'id', "user_id = '$user_id' ORDER BY `default` DESC, id DESC");
    
    // 数据封装
    $data['contact_id'] = $contact_id;
    $data['contact'] = $dou->get_row('user_contact', '*', "id = '$contact_id' AND user_id = '$user_id'");
}

/**
 * +----------------------------------------------------------
 * 预约提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'booking') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? trim($_REQUEST['id']) : '';
    $contact_id = $check->is_number($_REQUEST['contact_id']) ? trim($_REQUEST['contact_id']) : '';
    $date = $check->is_date($_REQUEST['date']) ? trim($_REQUEST['date']) : '';
    $time = $check->is_time($_REQUEST['time']) ? trim($_REQUEST['time']) : '';
 
    // 转为时间戳
    $timestamp = $dou_book->timestamp($date, $time);
    
    // 验证是否选择和选择的时间是否正确
    if (!$date || !$time) {
        $wrong = $_LANG['book_time_empty'];
    } elseif ($dou_book->booked($id, $date, $time, $user_id) || !$dou_book->time_with($id, $date, $time)) {
        $wrong = $_LANG['book_time_wrong'];
    }
    
    // 验证是否超过预约次数
    if (!$dou_book->check_number($id, $contact_id))
        $wrong = $_LANG['book_number_out'];
 
    // 判断联系人
    if (!$contact_id || !$dou->value_exist('user_contact', 'id', $contact_id, "user_id = '$user_id'"))
        $wrong = $_LANG['book_contact_wrong'];
 
    if ($wrong) {
        $data['wrong'] = $wrong;
        die(json_encode($data));
    }
    
    // 格式化
    $item = $dou->get_row('book_item', '*', "id = '$id'");
    $contact = $dou->get_row('user_contact', '*', "id = '$contact_id'");
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    $ip = $dou->get_ip();
    $add_time = time();
    $book_sn = $dou_book->create_book_sn();
    
    $sql = "INSERT INTO " . $dou->table('book') . " (id, book_sn, user_id, class_id, item_id, contact_id, name, telphone, card, date, time, timestamp, ip, add_time)" . " VALUES (NULL, '$book_sn', '$user_id', '$item[class_id]', '$item[id]', '$contact_id', '$contact[name]', '$contact[telphone]', '$contact[card]', '$date', '$time', '$timestamp', '$ip', '$add_time')";
    $dou->query($sql);
    
    // 数据封装
    $data['msg'] = $_LANG['book_success'];
}

/**
 * +----------------------------------------------------------
 * 会员中心
 * +----------------------------------------------------------
 */
elseif ($rec == 'user') {
    // 超时取消预约
    $dou_book->auto_update_status("user_id = '$user_id'");
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('book') . " WHERE user_id = '$user_id' ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $_URL['sub']['user']);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $book_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "item_name" => $dou->get_value('book_item', 'name', "id = '$row[item_id]'"),
                "name" => $row['name'],
                "telphone" => $row['telphone'],
                "card" => $row['card'],
                "time" => $row['date'] . ' ' . $row['time'],
                "status" => $dou->data_lang_format('book_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }

    // 数据封装
    $data['book_list'] = $book_list;
}

/**
 * +----------------------------------------------------------
 * 工作端
 * +----------------------------------------------------------
 */
elseif ($rec == 'work') {
    // 权限验证
    if (!$dou_work->check_permission($_CUR, $user_id)) {
        $data['wrong'] = $_LANG['work_no_permission'];
        die(json_encode($data));
    }

    // 超时取消预约
    $dou_book->auto_update_status();
 
    // 初始化
    $page_url = $_URL['sub']['work'];
 
    // 用户名
    $info = preg_match("/^[0-9\x{4e00}-\x{9fa5}]+$/u", $_REQUEST['info']) ? $_REQUEST['info'] : '';
    if ($info) {
        $and = " AND (name = '$info' OR telphone LIKE '%$info%')";
        $page_url = $page_url . "&info=$info";
    }
    
    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $and = $and . " AND time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $and = $and . " AND time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $page_url = $dou->param($page_url);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('book') . " WHERE status = 0" . $and . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 25, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $book_list[$row['id']] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "item_name" => $dou->get_value('book_item', 'name', "id = '$row[item_id]'"),
                "name" => $row['name'],
                "telphone" => $row['telphone'],
                "card" => $row['card'],
                "time" => $row['date'] . ' ' . $row['time'],
                "status" => $dou->data_lang_format('book_status_', $row['status']),
                "consumed" => $row['status'] ? true : false,
                "url_action" => $dou->param($_URL['sub']['consume'] . '&id=' . $row['id']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 数据封装
    $data['book_list'] = $book_list;
    $data['req'] = $_REQUEST;
}

/**
 * +----------------------------------------------------------
 * 工作端 核销
 * +----------------------------------------------------------
 */
elseif ($rec == 'consume') {
    // 获取请求
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    // 权限验证
    if (!$dou_work->check_permission($_CUR, $user_id)) {
        $data['wrong'] = $_LANG['work_no_permission'];
        die(json_encode($data));
    }
    
    $dou->query("UPDATE " . $dou->table('book') . " SET status = '1' WHERE id = '$id'");
    
    // 数据封装
    $data['msg'] = $_LANG['book_work_consume_success'];
}

echo json_encode($data);

?>