// pages/book/book.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
      contact:'',
      contact_list:[],
      isVisible: false, // 初始状态为显示
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    that.setData({
      title: app.title.book
    })
   
    // 设置转发标题缓存
    wx.setStorageSync('shareTitle', app.title.book)
    
    // 显示转发按钮
    dou.showShareMenu()
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'book.php?rec=contact',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: options.id,
        date: options.date,
        time: options.time
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong, '/pages/book/detail')
        } else {
          that.setData({
            item: res.data.item,
            date: res.data.date,
            time: res.data.time,
            time_format: res.data.time_format
          })
        }
      }
    })
   
    that.setData({
      id: options.id
    })
    
    that.contactList()
    that.contactSelect()
  },
        
  // 联系人列表
  contactList:function() {
    var that = this;

    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=list',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        contact_id: that.data.contact.id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          contact_list: res.data.contact_list
        })
      }
    })
  },

  // 选择联系人
  contactSelect:function(e) {
    var that = this;
    var contact_id = e ? e.currentTarget.dataset.contact_id : '';

    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=info',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        contact_id: contact_id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.contact) {
          that.setData({
            contact: res.data.contact
          })
          that.contactList();
          if (contact_id) {
            that.contactPopup(); // 关闭弹出窗口
          }
        }
      }
    })
  },
        
  // 联系人列表弹出
  contactPopup:function() {
    this.setData({
      isVisible: !this.data.isVisible // 切换状态
    })
  },
 
  bookSubmit: function () {
    var that = this

    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')

    wx.request({
      url: app.mp_url + 'book.php?rec=booking',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: that.data.id,
        date: that.data.date,
        time: that.data.time,
        contact_id: that.data.contact.id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          dou.douMsg(res.data.msg, '/pages/book/user')
        }
      }
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})