// pages/book/book.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    item_list: [],
    id: '',
    content: ''
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    that.setData({
      title: app.title.book_detail
    })
   
    // 设置转发标题缓存
    wx.setStorageSync('shareTitle', app.title.book_detail)
    
    // 显示转发按钮
    dou.showShareMenu()
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'book.php?rec=detail',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: options.id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          book: res.data.book,
          content: res.data.book.content
        })
      }
    })
    
    that.setData({
      id: options.id
    })
    that.dateList()
  },

  // 日期列表
  dateList: function(current_date = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'book.php?rec=date',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: that.data.id,
        current_date: current_date
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        var date = current_date ? current_date : res.data.date;
        
        that.setData({
          date_list: res.data.date_list,
          date: date
        })
        
        that.timeList(date)
      }
    })
  },

  // 选择日期
  dateSelect: function(e) {
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    this.setData({
      time: ''
    })
    this.dateList(e.currentTarget.dataset.date)
    this.timeList(e.currentTarget.dataset.date)
  },

  // 时间列表
  timeList: function(date = '', current_time = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'book.php?rec=time',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        id: that.data.id,
        date: date,
        current_time: current_time
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          time_list: res.data.time_list
        })
      }
    })
  },

  // 选择时间
  timeSelect: function(e) {
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    if (!e.currentTarget.dataset.booked) {
      this.setData({
        time: e.currentTarget.dataset.time
      })
     
      this.timeList(this.data.date, e.currentTarget.dataset.time)
    }
  },
 
  formSubmit: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.navigateTo ({
      url: '/pages/book/contact?id=' + that.data.id + '&date=' + that.data.date + '&time=' + that.data.time
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})