// pages/book/user.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    book_list: [],
    page: 1, // 初始页默认值为1
    nomore: false
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    that.setData({
      title: app.title.book_user
    })
   
    // 设置转发标题缓存
    wx.setStorageSync('shareTitle', app.title.book_user)
    
    // 显示转发按钮
    dou.showShareMenu()
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    that.loadData()
  },

  // 获取数据
  loadData: function(concat = false, page = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'book.php?rec=work',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        page: page ? page : that.data.page, // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (concat) {
          var dataBox = that.data.book_list; // 从data获取当前datalist数组
          var dataNew = res.data.book_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.book_list;
        }
        
        that.setData({
          book_list: dataBox,
          loadpage: false
        })
      }
    })
  },
 
  onReachBottom: function () { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },
 
  test(e) {
    this.loadData(true)
  },
 
  // 核销
  consume(e) {
    var that = this;
    
    wx.showModal({
      title: e.currentTarget.dataset.item_name, // 提示框标题
      content: that.data.lang.book_time + '：' + e.currentTarget.dataset.time + '\r\n' + that.data.lang.book_telphone + '：' + e.currentTarget.dataset.telphone, // 提示框内容
      success(res) {
        if (res.confirm) {
          wx.request({
            url: app.mp_url + 'book.php?rec=consume',
            data: {
              user_id: wx.getStorageSync('user_id'),
              shell: wx.getStorageSync('shell'),
              id: e.currentTarget.dataset.id
            },
            header: {
              'Connect-Key' : wx.getStorageSync('connect_key')
            },
            success: function(res) {
              if (res.data.wrong) {
                dou.douMsg(res.data.wrong)
              } else {
                dou.douMsg(res.data.msg)
                
                var book_list = that.data.book_list;
                const index = e.currentTarget.dataset.id;
                const key = 'consumed';
                that.setData({
                  [`book_list.${index}.${key}`]: true
                });
              }
            }
          })
        } else if (res.cancel) {
          // 用户点击了“取消”
          console.log('用户点击了取消');
        }
      }
    });
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})