/**
 +----------------------------------------------------------
 */
$(document).ready(function() {
    
});

/**
 +----------------------------------------------------------
 */
var vm = new Vue({
    el:'#book',
    data:{
        date_list:[],
        time_list:[],
        contact:'',
        contact_list:[],
        isVisible: false, // 初始状态为显示
        id: id,
        date:'',
        time:'',
        wrong:''
    },
    
    mounted: function () {
        dou_url();
        
        if (rec == 'detail') {
            this.dateList();
        } else if (rec == 'contact') {
            this.contactSelect();
            this.contactList();
        }

        //将Vue方法传到全局对象window中
        window.timeList = this.timeList;
        window.time = this.time;
    },
    
    methods:{
        // 日期列表
        dateList:function(current_date) {
            this.$http.post(window.url.sub.date,{id:this.id, current_date:current_date},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                var date = current_date ? current_date : res.data.date;
                
                if (res.data.date_list) {
                    this.date_list = res.data.date_list;
                    this.date = date;
                    this.timeList(date);
                }
            },function(res){
                console.log(res.data)
            })
        },
        
        // 选择日期
        dateSelect:function(data) {
            this.dateList(data.date);
            this.timeList(data.date);
            this.time = '';
        },
        
        // 时间列表
        timeList:function(date, current_time) {
            this.$http.post(window.url.sub.time,{id:this.id, date:date, current_time:current_time},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                if (res.data.time_list) {
                    this.time_list = res.data.time_list;
                }
            },function(res){
                console.log('失败')
            })
        },
        
        // 选择时间
        timeSelect:function(item) {
            if (!item.booked) {
                this.time = item.time;
                this.timeList(this.date, item.time);
            }
        },
        
        // 联系人列表
        contactList:function() {
            this.$http.post(root_url + 'user.php?rec=contact&act=list',{contact_id:this.contact.id},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                if (res.data.contact_list) {
                    this.contact_list = res.data.contact_list;
                }
            },function(res){
                console.log('失败')
            })
        },
        
        // 选择联系人
        contactSelect:function(contact_id) {
            this.$http.post(root_url + 'user.php?rec=contact&act=info',{contact_id:contact_id},{emulateJSON:true}).then(function(res){
                if (res.data.wrong) {
                    alert(res.data.wrong);
                }
                
                if (res.data.contact) {
                    this.contact = res.data.contact;
                    this.contactList();
                    if (contact_id) {
                        this.contactPopup(); // 关闭弹出窗口
                    }
                }
            },function(res){
                console.log('失败')
            })
        },
        
        // 联系人列表弹出
        contactPopup:function() {
            this.isVisible = !this.isVisible; // 切换状态
        },
    },
    
    destroyed() {
        // 在页面销毁后，清除计时器
        this.clear();
    }
})